-- phpMyAdmin SQL Dump
-- version 3.3.9
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: May 11, 2020 at 08:14 AM
-- Server version: 5.5.8
-- PHP Version: 5.3.5

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `newcms`
--

-- --------------------------------------------------------

--
-- Table structure for table `fx_admin_menu`
--

CREATE TABLE IF NOT EXISTS `fx_admin_menu` (
  `adminMenuID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menuType` tinyint(1) NOT NULL DEFAULT '0',
  `menuTitle` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `seoUri` varchar(100) COLLATE utf8_unicode_ci NOT NULL DEFAULT '#',
  `xOrder` int(3) NOT NULL DEFAULT '0',
  `parentID` int(11) NOT NULL DEFAULT '0',
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`adminMenuID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=14 ;

--
-- Dumping data for table `fx_admin_menu`
--

INSERT INTO `fx_admin_menu` (`adminMenuID`, `menuType`, `menuTitle`, `seoUri`, `xOrder`, `parentID`, `status`) VALUES
(3, 0, 'Menu', 'menu', 0, 0, 1),
(4, 0, 'Page', 'page', 0, 0, 1),
(5, 0, 'Category', 'category', 0, 0, 1),
(11, 0, 'Blog', 'blog', 0, 0, 1),
(10, 0, 'Contact', 'contact', 0, 0, 1),
(12, 0, 'Home slider', 'home-slider', 0, 0, 1),
(13, 0, 'Leave comment', 'leave-comment', 0, 0, 1);

-- --------------------------------------------------------

--
-- Table structure for table `fx_admin_meta_setting`
--

CREATE TABLE IF NOT EXISTS `fx_admin_meta_setting` (
  `metaSettingID` int(11) NOT NULL AUTO_INCREMENT,
  `sitePage` varchar(100) NOT NULL,
  `adminMod` varchar(100) NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`metaSettingID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `fx_admin_meta_setting`
--


-- --------------------------------------------------------

--
-- Table structure for table `fx_admin_role`
--

CREATE TABLE IF NOT EXISTS `fx_admin_role` (
  `roleAID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `roleName` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`roleAID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=5 ;

--
-- Dumping data for table `fx_admin_role`
--

INSERT INTO `fx_admin_role` (`roleAID`, `roleName`, `status`) VALUES
(1, 'Admin', 1),
(2, 'IT', 1),
(3, 'Store', 1),
(4, 'Products ', 1);

-- --------------------------------------------------------

--
-- Table structure for table `fx_admin_setting`
--

CREATE TABLE IF NOT EXISTS `fx_admin_setting` (
  `settingID` int(11) NOT NULL AUTO_INCREMENT,
  `settingName` varchar(100) NOT NULL,
  `seoUri` varchar(100) NOT NULL,
  `settingVal` varchar(255) NOT NULL,
  `settingDefault` varchar(255) NOT NULL,
  PRIMARY KEY (`settingID`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=7 ;

--
-- Dumping data for table `fx_admin_setting`
--

INSERT INTO `fx_admin_setting` (`settingID`, `settingName`, `seoUri`, `settingVal`, `settingDefault`) VALUES
(1, 'Logo', 'logo', 'logo-0058476001535028609.png', 'logo.png'),
(2, 'Favicon', 'favicon', 'favicon-0060976001535028609.png', 'favicon.ico'),
(3, 'Page Title', 'page-title', 'Angad', '4Fox Solutions'),
(4, 'Theme', 'theme', '', 'default'),
(5, 'Default Page', 'default-page', 'category', 'page'),
(6, 'Editor', 'editor', 'Full', 'Full');

-- --------------------------------------------------------

--
-- Table structure for table `fx_admin_site_meta`
--

CREATE TABLE IF NOT EXISTS `fx_admin_site_meta` (
  `siteMetaID` int(11) NOT NULL AUTO_INCREMENT,
  `sitePage` varchar(100) NOT NULL,
  `adminMod` varchar(100) NOT NULL,
  `metaID` int(11) NOT NULL,
  `seoUri` varchar(256) NOT NULL,
  `metaTitle` varchar(256) NOT NULL,
  `metaKeyword` varchar(165) NOT NULL,
  `metaDesc` varchar(256) NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`siteMetaID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `fx_admin_site_meta`
--


-- --------------------------------------------------------

--
-- Table structure for table `fx_admin_user`
--

CREATE TABLE IF NOT EXISTS `fx_admin_user` (
  `userID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `roleAID` int(5) NOT NULL DEFAULT '0',
  `displayName` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `userName` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `userPass` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `userEmail` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `imageName` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `dateAdded` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `dateModified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `dateLogin` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `loginKey` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `activationKey` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`userID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=2 ;

--
-- Dumping data for table `fx_admin_user`
--

INSERT INTO `fx_admin_user` (`userID`, `roleAID`, `displayName`, `userName`, `userPass`, `userEmail`, `imageName`, `dateAdded`, `dateModified`, `dateLogin`, `loginKey`, `activationKey`, `status`) VALUES
(1, 1, 'Admin', 'admin', '21232f297a57a5a743894a0e4a801fc3', 'amrit@4fox.in', '', '2013-11-23 11:04:16', '2014-08-06 19:10:37', '2018-12-07 16:56:10', '', '', 1);

-- --------------------------------------------------------

--
-- Table structure for table `fx_admin_user_access`
--

CREATE TABLE IF NOT EXISTS `fx_admin_user_access` (
  `userAccessID` int(11) NOT NULL AUTO_INCREMENT,
  `roleAID` int(11) NOT NULL,
  `adminMenuID` int(11) NOT NULL,
  `accessType` text COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`userAccessID`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1078 ;

--
-- Dumping data for table `fx_admin_user_access`
--

INSERT INTO `fx_admin_user_access` (`userAccessID`, `roleAID`, `adminMenuID`, `accessType`) VALUES
(722, 3, 58, '["view"]'),
(1077, 1, 100000, '["view","add","edit","delete","trash","restore"]'),
(1076, 1, 13, '["view","add","edit","delete","trash","restore"]'),
(1075, 1, 12, '["view","add","edit","delete","trash","restore"]'),
(1074, 1, 10, '["view","add","edit","delete","trash","restore"]'),
(1073, 1, 11, '["view","add","edit","delete","trash","restore"]'),
(1072, 1, 5, '["view","add","edit","delete","trash","restore"]'),
(1071, 1, 4, '["view","add","edit","delete","trash","restore"]'),
(1070, 1, 3, '["view","add","edit","delete","trash","restore"]');

-- --------------------------------------------------------

--
-- Table structure for table `fx_category`
--

CREATE TABLE IF NOT EXISTS `fx_category` (
  `categoryID` int(11) NOT NULL AUTO_INCREMENT,
  `parentID` int(11) NOT NULL,
  `categoryTitle` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `categoryImage` varchar(256) NOT NULL,
  `seoUri` varchar(255) NOT NULL,
  `colorCode` varchar(50) NOT NULL,
  `templateFile` varchar(100) NOT NULL,
  `metaTitle` varchar(255) NOT NULL,
  `metaKeyword` text NOT NULL,
  `metaDesc` text NOT NULL,
  `dateAdded` datetime NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`categoryID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `fx_category`
--


-- --------------------------------------------------------

--
-- Table structure for table `fx_menu`
--

CREATE TABLE IF NOT EXISTS `fx_menu` (
  `menuID` int(11) NOT NULL AUTO_INCREMENT,
  `parentID` int(11) NOT NULL,
  `menuTitle` varchar(255) NOT NULL,
  `synopsis` text NOT NULL,
  `metaTitle` varchar(256) NOT NULL,
  `metaKeyword` text NOT NULL,
  `metaDesc` text NOT NULL,
  `menuType` varchar(100) NOT NULL,
  `seoUri` varchar(255) NOT NULL,
  `menuClass` varchar(50) NOT NULL,
  `xOrder` int(2) NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`menuID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `fx_menu`
--


-- --------------------------------------------------------

--
-- Table structure for table `fx_otherdata`
--

CREATE TABLE IF NOT EXISTS `fx_otherdata` (
  `otherdataID` int(11) NOT NULL AUTO_INCREMENT,
  `data_key` text NOT NULL,
  `data_value` text NOT NULL,
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`otherdataID`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14 ;

--
-- Dumping data for table `fx_otherdata`
--

INSERT INTO `fx_otherdata` (`otherdataID`, `data_key`, `data_value`, `status`) VALUES
(1, 'btnSubmit', 'UPDATE', 1),
(3, 'xAction', 'UPDATE', 1),
(4, 'TBL', 'otherdata', 1),
(5, 'PK', 'otherdataID', 1),
(6, 'fxValidate', '%5B%5D', 1),
(7, 'facebookLink', 'https://www.facebook.com/MnchndaAnngad', 1),
(8, 'twitterLink', 'https://twitter.com/typosingh', 1),
(9, 'googleplusLink', 'https://www.google.co.in', 1),
(10, 'instagramLink', 'https://www.instagram.com/anngad_mnchnda/', 1),
(11, 'youtubeLink', 'https://www.linkedin.com/in/angadsinghmanchanda/', 1);

-- --------------------------------------------------------

--
-- Table structure for table `fx_page`
--

CREATE TABLE IF NOT EXISTS `fx_page` (
  `pageID` int(11) NOT NULL AUTO_INCREMENT,
  `seoUri` varchar(255) NOT NULL,
  `pageTitle` varchar(255) NOT NULL,
  `synopsis` text NOT NULL,
  `pageContent` text NOT NULL,
  `pageImage` varchar(100) NOT NULL,
  `templateFile` varchar(100) NOT NULL,
  `dateAdded` datetime NOT NULL,
  `dateModified` datetime NOT NULL,
  `modifiedBy` int(11) NOT NULL DEFAULT '1',
  `status` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`pageID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Dumping data for table `fx_page`
--

